--------------------------------------------------------------------------------
--
-- Talent walking
--
--------------------------------------------------------------------------------
function HotMan:addTalentHandler(talentName, handler)
	self.talentHandlers[talentName] = handler
end

function HotMan:buildTalentHandlers()
	self.talentHandlers = {}
	self.talents = {}
	
	-- Druid talents
	self:addTalentHandler( "Brutal Impact", BrutalImpact )
	--self:addTalentHandler( "Savage Fury", BrutalImpact )

	-- Priest talents
	self:addTalentHandler( "Improved Shadow Word: Pain", ImpSWP )
end

function HotMan:listTalents()
	self:Print("Talents:")
	for name,talent in pairs(self.talents) do
		self:Print("* "..name.." "..talent.rank.."/"..talent.maxRank..": "..talent.effect)
	end
end


function HotMan:walkTalents()
	local numTabs = GetNumTalentTabs();
	for t=1, numTabs do
		--if DEBUG then self:Print(GetTalentTabInfo(t)..":"); end
		local numTalents = GetNumTalents(t);
		for i=1, numTalents do
			nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(t,i);
			if currRank > 0 then
				--self:Print("- "..nameTalent..": "..currRank.."/"..maxRank)
				if self.talentHandlers[nameTalent] then
					--self:Print("   Running talent handler")
					func = self.talentHandlers[nameTalent]
					effect = func(currRank, maxRank)
					self.talents[nameTalent] = {rank=currRank, maxRank=maxRank, effect=effect} 
				end
			end
		end
	end
end

function BrutalImpact( rank, maxRank )
	spells = {"Pounce", "Bash"}
	for key,spellName in pairs(spells) do
		spell = getHOT(spellName)
		spell.duration = spell.duration + rank * 0.5
	end	
	return "Increase Pounce and Bash duration by "..(rank*0.5).." second(s)"
end

function ImpSWP( rank, maxRank )
	spells = {"Shadow Word: Pain"}
	for key,spellName in pairs(spells) do
		spell = getHOT(spellName)
		spell.duration = spell.duration + rank * 3
	end	
	return "Increase SWP duration by "..(rank*3).." second(s)"
end